(*
  This is a CLXDisplay API Clipboard monitoring and hooks demo
  main unit.
  (c) Andrei Borovsky, 2001. < borovsky@yandex.ru >
  You may do with this file whatever you want, but remember that
  I'm not responcible for any consequences.
*)

unit main;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs, Qt,
  QStdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    Label2: TLabel;
    Button1: TButton;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    CBHook : QClipboard_hookH;
    CB : QClipboardH;
    ButtonHook : QButton_hookH;
    procedure ClipboardDataChanged; cdecl;
    procedure ButtonPressed; cdecl;
    procedure ButtonReleased; cdecl;
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  M : TMethod;
begin
  CB:=QApplication_clipboard;
  CBHook:=QClipboard_hook_create(CB);
  QClipboard_dataChanged_Event(M):=ClipboardDataChanged;
  QClipboard_hook_hook_dataChanged(CBHook, M);
  ButtonHook:=QButton_hook_create(Button1.Handle);
  QButton_pressed_Event(M):=ButtonPressed;
  QButton_hook_hook_pressed(ButtonHook, M);
  QButton_released_Event(M):=ButtonReleased;
  QButton_hook_hook_released(ButtonHook, M);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  QClipboard_hook_destroy(CBHook);
  QButton_hook_destroy(ButtonHook);
end;

procedure TForm1.ClipboardDataChanged;
var
  QMS : QMimeSourceH;
  S : WideString;
  S1 : String;
  i : Integer;
begin
  QMS:=QClipboard_data(CB);
  Memo1.Lines.Clear;
  (* enumerating clipboard data formats *)
  i:=0;
  S1:=QMimeSource_format(QMS, i);
  while S1<>'' do
  begin
    Memo1.Lines.Add(S1);
    Inc(i);
    S1:=QMimeSource_format(QMS, i);
  end;
  Label3.Caption:='';
  (* if text data is available, we retrieve it *)
  if QTextDrag_canDecode(QMS) then
  begin
    QTextDrag_Decode(QMS, @S);
    Label3.Caption:=S;
  end;
end;

procedure TForm1.ButtonPressed;
begin
  Label4.Font.Color:=clRed;
  Label4.Caption:='The Button is pressed !';
end;

procedure TForm1.ButtonReleased;
begin
  Label4.Font.Color:=clBlue;
  Label4.Caption:='The Button is released !';
end;

end.
